<?php

namespace App\Filesystem;

use App\Task\TaskInterface;

/**
 * Class to create a new directory
 *
 * @author Phil Burton <phil@d3r.com>
 */
class CreateDirectory implements TaskInterface
{
    /**
     * Directory to create
     *
     * @var string
     */
    protected $directory;

    /**
     * Check if the directory already exists
     *
     * @param string $filename
     * @author Phil Burton <phil@d3r.com>
     */
    public function __construct(string $directory)
    {
        $this->directory = $directory;

        if (!is_writable(dirname($directory))) {
            throw new \Exception('Cannot create directory at: ' . $directory);
        }

        if (file_exists($directory)) {
            throw new \Exception('Directory already exists at: ' . $directory);
        }
    }

    /**
     * Create the new directory
     *
     * @author Phil Burton <phil@d3r.com>
     */
    public function execute()
    {
        mkdir($this->directory);
    }
}
